
import static javax.persistence.PersistenceContextType.EXTENDED;

import java.util.List;

import javax.ejb.Remove;
import javax.ejb.Stateful;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.jboss.seam.annotations.Begin;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.datamodel.DataModel;
import org.jboss.seam.annotations.datamodel.DataModelSelection;

@Stateful
@Name("todoDao")
public class TodoDao implements TodoDaoInt {

  @In (required=false) @Out (required=false)
  private Todo todo;
  
  @PersistenceContext (type=EXTENDED)
  private EntityManager em;

  @DataModel
  private List<Todo> todos;

  @SuppressWarnings("unchecked")
  @Factory("todos")
  @Begin(join=true)
  public void findTodos () {
    todos = em.createQuery("select t from Todo t").getResultList();
  }

  public String persist () {
    em.persist (todo);
    
    if (todos != null) {
    	todos.add(todo);
    }
    
    return "persisted";
  }

  public String delete () {
    em.remove( todo );
    
    todos.remove(todo);
    todo = null;
    
    return "removed";
  }

  public String update () {
    return "updated";
  }
  
  public String edit() {
	  return "edit";
  }
  
  public String select() {
	  System.out.println("current selection=" + todo);
	  
	  return "";
  }

  @Remove @Destroy
  public void destroy() {}

  @Begin(join=true)
  public String create() {
	todo = new Todo();
	  
	return "create";
  }


}

